# This file has been autogenerated by the pywayland scanner

# Copyright 2016 The Chromium Authors.
# Copyright 2017 Intel Corporation
# Copyright 2018 Collabora, Ltd
# Copyright 2021 Simon Ser
#
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice (including the next
# paragraph) shall be included in all copies or substantial portions of the
# Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.

from __future__ import annotations

from pywayland.protocol_core import Global, Interface, Proxy, Resource


class WpLinuxDrmSyncobjTimelineV1(Interface):
    """Synchronization object timeline

    This object represents an explicit synchronization object timeline imported
    by the client to the compositor.
    """

    name = "wp_linux_drm_syncobj_timeline_v1"
    version = 1


class WpLinuxDrmSyncobjTimelineV1Proxy(Proxy[WpLinuxDrmSyncobjTimelineV1]):
    interface = WpLinuxDrmSyncobjTimelineV1

    @WpLinuxDrmSyncobjTimelineV1.request()
    def destroy(self) -> None:
        """Destroy the timeline

        Destroy the synchronization object timeline. Other objects are not
        affected by this request, in particular timeline points set by
        set_acquire_point and set_release_point are not unset.
        """
        self._marshal(0)
        self._destroy()


class WpLinuxDrmSyncobjTimelineV1Resource(Resource):
    interface = WpLinuxDrmSyncobjTimelineV1


class WpLinuxDrmSyncobjTimelineV1Global(Global):
    interface = WpLinuxDrmSyncobjTimelineV1


WpLinuxDrmSyncobjTimelineV1._gen_c()
WpLinuxDrmSyncobjTimelineV1.proxy_class = WpLinuxDrmSyncobjTimelineV1Proxy
WpLinuxDrmSyncobjTimelineV1.resource_class = WpLinuxDrmSyncobjTimelineV1Resource
WpLinuxDrmSyncobjTimelineV1.global_class = WpLinuxDrmSyncobjTimelineV1Global
